#include <stdio.h>
#define MAX_QUEUE_SIZE  10
#define FALSE 0
#define TRUE  1
typedef struct QUEUE {
  int queue[MAX_QUEUE_SIZE];
  int front, rear;
} QUEUE;
int put(int data, QUEUE *q)
{
  if ( (q->rear + 1) % MAX_QUEUE_SIZE == q->front)
  {
	printf("\nOOPs, Queue Overflow!!\n");
	return FALSE;
  }
  q->queue[q->rear] = data;
  q->rear = ++q->rear % MAX_QUEUE_SIZE;
  return data;
}
int get(QUEUE *q)
{
  if (q->front == q->rear) {
	printf("\nOOps, Queue Underflow!!\n");
	return FALSE;
  }
  q->front = ++q->front % MAX_QUEUE_SIZE;
  return q->queue[q->front-1];
}
int init_queue(QUEUE *q)
{
  if (!q) return FALSE;
  q->front = 0;
  q->rear = 0;
  memset(q->queue, 0, MAX_QUEUE_SIZE);
  return TRUE;
}
void print_queue(QUEUE *q)
{
  int i;
  for (i=q->front; i!=q->rear; i = ++i % MAX_QUEUE_SIZE)
  {
	if (i == q->front)
	  printf("queue[%d]|%8d| <-- front\n", i, q->queue[i]);
	else
	  printf("queue[%d]|%8d|\n", i, q->queue[i]);
  }
  printf("queue[%d]|%8c| <-- rear\n", q->rear,' ');

}
int main()
{
  QUEUE q;
  init_queue(&q);
  printf("\nNow putting data: 200, 300, 850\n\n");
  put(200, &q);
  put(300, &q);
  put(850, &q);
  print_queue(&q);
  printf("\ngetting data: %d\n\n", get(&q));
  print_queue(&q);
  printf("\ngetting data: %d\n\n", get(&q));
  print_queue(&q);
  printf("\ngetting data: %d\n\n", get(&q));
  print_queue(&q);
  get(&q);
  return 0;
}