#include <stdio.h>
#include <dos.h>
typedef struct disk_info {
  int spc;    /* sectors per cluster */
  int uuc;    /* unused clusters */
  int bps;    /* bytes per sector */
  int ttc;    /* total clusters */
} DISKINFO;
void getDiskinfo(char drive, DISKINFO *di)
{
  union REGS r;
  r.h.ah = 0x36;
  r.h.dl = drive - 'A' + 1;
  int86(0x21, &r, &r);
  di->spc = r.x.ax;
  di->uuc = r.x.bx;
  di->bps = r.x.cx;
  di->ttc = r.x.dx;
}
int main(int argc, char *argv[])
{
  DISKINFO di;
  if (argc < 2) {
	printf("OOps! You should give me the drive name like 'A','B',...\n");
	printf("usage : diskinfo <drive>\n");
	exit(0);
  }
  printf("[ DISK INFORMATION ]\n");
  getDiskinfo(toupper(argv[1][0]), &di);
  printf("DRIVE : %c\n", argv[1][0]);
  printf("Sectors per cluster = %d\n", di.spc);
  printf("Unused clusters = %d\n", di.uuc);
  printf("Bytes per sector = %d\n", di.bps);
  printf("Total clusters = %d\n", di.ttc);
  printf("Total disk space = %ld bytes\n", (unsigned long) di.spc * di.ttc * di.bps);
  printf("Used disk space = %ld bytes\n", (unsigned long) di.spc * (di.ttc-di.uuc) * di.bps);
  printf("Available disk space = %ld bytes\n", (unsigned long) di.spc * di.uuc * di.bps);
  return 0;
}
