#ifndef __MEMBER_H__
#define __MEMBER_H__
#ifndef TRUE
  #define FALSE        0
  #define TRUE         1
#endif
typedef struct FILE_HEADER {
  char pname[10];       /* the title of program */
  char version[10];      /* the version */
  unsigned long recnt;   /* record count */
  unsigned long delcnt;  /* deleted record count */
  unsigned long serial;  /* serial no */
} DFH;

typedef struct MEMBER {
   unsigned long no;
   char usrid[10];
   char paswd[10];
   char name[20];
   char sex[2];
   int  age;
   char position[20];
   char company[30];
   char address[40];
   char zipcode[7];
   char tel[15];
   char cel[15];
} MEMBER_REC;

typedef struct INDEX {
   char usrid[10];
   unsigned long offset;
   char flag;    /* delete or not flag */
} INDEX_REC;

typedef enum field_type { NO, USRID, PASWD, NAME, SEX, AGE, POSITION,
  COMPANY, ADDRESS, ZIPCODE, TEL, CEL } FIELD_NO; /* field type */

/* field x, y, width, height, attribute */
typedef struct {
  int x, y, w, h, a;
  char buf[80];
  int i;  /* buffer index */
} FIELD;

typedef struct fields {
  FIELD no, usrid, paswd, name, sex, age,
  position, company, address, zipcode, tel, cel;
} FIELDS;

typedef enum mode {
	INSERT, SAVE, SEARCH, LIST, MODIFY, INDEXING, INITDATA
} MODE;

extern char *datfile;  /*    */
extern char *idxfile;   /*    */

extern MODE mode;

void clear_field(FIELD_NO no);
void delete_member(char *);
void disk_swap(FILE *, unsigned long, unsigned long);
int  disk_comp(FILE *, unsigned long, unsigned long);
void display_member(MEMBER_REC *);
long find_member(const char *, MEMBER_REC *);
void fqsort(FILE *, long, long);
long fbin_search(const char *, long, FILE *);
unsigned long get_recount(void);
unsigned long get_serial(void);
unsigned long get_offset(const char *);
int  indexing(void);
void init_file(void);
void insert_member(void);
void list_member(long);
void make_field(FIELD *f);
void modify_member(void);
void print_title(void);
int  save_data(MEMBER_REC *);
int  set_delete(const char *);
void search_member(void);
void set_field(MEMBER_REC *m);
#endif